<!DOCTYPE html>
<html lang="en">
<head>
    <title>task 42.120</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <h2 class="text-center">DANH SÁCH ĐƠN HÀNG</h2>
    </div>
    <!-- Table -->
    <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
            <tr>
                <th>Order Code</th>
                <th>Kích cỡ</th>
                <th>Loại Pizza</th>
                <th>Nước uống</th>
                <th>Thành tiền</th>
                <th>Họ và tên</th>s
                <th>Số điện thoại</th>
                <th>Trạng thái</th>
                <th>Action</th>
            </tr>
            <tbody>

            </tbody>
        </thead>
    </table>
    <!-- Modal -->
    <div>
        <div id="order-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Chi tiết đơn hàng</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-order-code">Order Code</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-order-code" name="orderCode" placeholder="Order code"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="select-size-pizza">Pizza size</label>
                    </div>
                    <div class="col-sm-9">
                        <select id="select-size-pizza" class="form-control" type="text"></select>
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-duong-kinh">Đường kính</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-duong-kinh" name="duongKinh" placeholder="Đường kính"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-suon">Sườn</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-suon" name="suon" placeholder="Sườn"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-salad">Salad</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-salad" name="salad" placeholder="Salad"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-pizza-type">Pizza Type</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="inp-pizza-type" name="pizzaType" placeholder="Pizza Type" class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-idvoucher">ID Voucher</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-idvoucher" name="idvoucher" placeholder="ID Voucher"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-thanh-tien">Thành tiền</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-thanh-tien" name="thanhTien" placeholder="Thành tiền"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-giam-gia">Giảm giá</label>
                    </div>
                    <div class="col-sm-9">
                      <input type="text" id="input-giam-gia" name="giamGia" placeholder="Giảm giá"
                        class="form-control">
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="select-do-uong">Loại đồ uống</label>
                    </div>
                    <div class="col-sm-9">
                        <select id="select-do-uong" class="form-control" type="text"></select>
                    </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-so-luong-nuoc">Số lượng nước uống</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-so-luong-nuoc" name="soLuongNuoc" placeholder="Số lượng nước uống"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-full-name">Họ và tên</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-full-name" name="hoVaTen" placeholder="Họ và tên"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-full-name">Email</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-email" name="email" placeholder="Email"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-phone">Số điện thoại</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-phone" name="phone" placeholder="Số điện thoại"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-address">Địa chỉ</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-address" name="address"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-message">Lời nhắn</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-message" name="message"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-ngay-order">Ngày order</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-ngay-order" name="ngayOrder"
                          class="form-control">
                      </div>
                  </div>

                  <div class="row form-group">
                    <div class="col-sm-3">
                      <label for="input-ngay-chinhsua">Ngày chỉnh sửa</label>
                    </div>
                    <div class="col-sm-9">
                        <input type="text" id="input-ngay-chinhsua" name="ngayChinhSua"
                          class="form-control">
                      </div>
                  </div>

                </form>
              </div>
              <div class="modal-footer">
                <div class="row">
                    <div class="col-sm-6">
                      <button id="btn-confirm" class="col-sm-12 btn btn-success">Confirm</button>
                    </div>
                    <div class="col-sm-6">
                        <button id="btn-cancel" class="col-sm-12 btn btn-danger">Cancel</button>
                      </div>
                  </div>
                <button type="button" class="btn btn-secondary" id="btn-modal-close" data-dismiss="modal">Close</button>
              </div>
            </div>
          </div>
        </div>
      </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gOrder_Data = [];

    const gORDER_COL = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];

    const gORDER_CODE_COL = 0;
    const gKICH_CO_COL = 1;
    const gLOAI_PIZZA_COL = 2;
    const gNUOC_UONG_COL = 3;
    const gTHANH_TIEN_COL = 4;
    const gHO_TEN_COL = 5;
    const gSO_DT_COL = 6;
    const gTRANG_THAI_COL = 7;
    const gACTION_COL = 8;

    var gId = 0;
    var gOrderCode = 0;
    var gPizzaSize = ["S", "M", "L"];
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
        callApiDrinkSelect();
        getPizaaSize(gPizzaSize);

        $("#order-table").on("click", ".btn-detail", function(){
            onBtnClickDetail(this);
        })
        $("#btn-confirm").on("click", function(){
            onBtnClickConFirm();
        })
        $("#btn-cancel").on("click", function(){
            onBtnClickCancel();
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
         $("#order-table").DataTable({
            columns: [
                {data: gORDER_COL[gORDER_CODE_COL]},
                {data: gORDER_COL[gKICH_CO_COL]},
                {data: gORDER_COL[gLOAI_PIZZA_COL]},
                {data: gORDER_COL[gNUOC_UONG_COL]},
                {data: gORDER_COL[gTHANH_TIEN_COL]},
                {data: gORDER_COL[gHO_TEN_COL]},
                {data: gORDER_COL[gSO_DT_COL]},
                {data: gORDER_COL[gTRANG_THAI_COL]},
                {data: gORDER_COL[gACTION_COL]},
            ],
            columnDefs: [ 
            {
                targets: gACTION_COL,
                defaultContent: "<button class='btn-detail btn btn-info'>Chi tiết</button>"
            }]
        });
        getApiAllOrder();
    }

    function onBtnClickDetail(paramDetail){
        console.log("nút detail được nhấn");
 
        getDataFromTableRow(paramDetail);
        callApiFormOrder(gOrderCode);
        $("#order-modal").modal("show")


    }
    function onBtnClickConFirm(){

      var vConfirmObj = {
          trangThai: "confirmed"
      }
      console.log(JSON.stringify(vConfirmObj));
      console.log(gId);
      $.ajax({
          url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          dataType: "json",
          data: JSON.stringify(vConfirmObj),
          success: function(paramSuccess){
              confirmSuccess();
          },
          error: function(paramError){
              console.log(paramError.responseText);
          }
      })
    }
    function onBtnClickCancel(){

      var vCancelObj = {
          trangThai: "cancel"
      }
      console.log(JSON.stringify(vCancelObj));
      console.log(gId);
      $.ajax({
          url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          dataType: "json",
          data: JSON.stringify(vCancelObj),
          success: function(paramSuccess){
            cancelSuccess();
          },
          error: function(paramError){
              console.log(paramError.responseText);
          }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    function getApiAllOrder() {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
            type: "GET",
            dataType: "json",
            success: function(paramSuccess){
                gOrder_Data = paramSuccess;
                loadDataToTable(gOrder_Data);
            },
            error: function(paramError) {
                console.log(paramError.responseText);
            }
        })
    }
    function loadDataToTable(paramResponseObject){
        var vOrderTable = $("#order-table").DataTable();
        //Xóa toàn bộ dữ liệu đang có của bảng
        vOrderTable.clear();
        //Cập nhật data cho bảng 
        vOrderTable.rows.add(paramResponseObject);
        //Cập nhật lại giao diện hiển thị bảng
        vOrderTable.draw();
    }

    function getPizaaSize(paramPizza){
        $.each(paramPizza, function(i, item){
            $("#select-size-pizza").append($("<option>", {
                text: item,
                value: item.toLowerCase()
            }))
        })
    }
    function callApiDrinkSelect(){
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
            type: "GET",
            dataType: "json",
            success: function(paramSuccess){
                loadDrinkSelect(paramSuccess);
            },
            error: function(paramError){
                console.log(paramError.responseText);
            }
        })
    }
    function loadDrinkSelect(paramDrink){
        $.each(paramDrink, function(i, item){
            $("#select-do-uong").append($("<option>", {
                text: item.tenNuocUong,
                value: item.maNuocUong
            }))
        })
    }

    function getDataFromTableRow(paramBtnEdit) {
      // dung parentt() hoac closet('tr')
      let vTableRow = $(paramBtnEdit).parent();
      let vData = $("#order-table").DataTable();
      var vDaTaTable = vData.row(vTableRow).data();
      console.log(vDaTaTable)
      gOrderCode = vDaTaTable.orderCode;
      gId = vDaTaTable.id;
      console.log("order code: ", gOrderCode);
      console.log("ID: ", gId);
    }
    function callApiFormOrder(paramOrder){
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + paramOrder,
            type: "GET",
            dataType: "json",
            success: function(paramSuccess){
                console.log(paramSuccess);
                loadFormOrder(paramSuccess);
            },
            error: function(paramError){
                console.log(paramError.responseText);
            }
        })
    }
    function loadFormOrder(paramOrder){
        $("#input-order-code").val(paramOrder.orderCode);
        $("#select-size-pizza").val(paramOrder.kichCo.toLowerCase());
        $("#input-duong-kinh").val(paramOrder.duongKinh);
        $("#input-suon").val(paramOrder.suon);
        $("#input-salad").val(paramOrder.salad);
        $("#inp-pizza-type").val(paramOrder.loaiPizza);
        $("#input-idvoucher").val(paramOrder.idVourcher);
        $("#input-thanh-tien").val(paramOrder.thanhTien);
        $("#input-giam-gia").val(paramOrder.giamGia);
        $("#select-do-uong").val(paramOrder.idLoaiNuocUong);
        $("#input-so-luong-nuoc").val(paramOrder.soLuongNuoc);
        $("#input-full-name").val(paramOrder.hoTen);
        $("#input-email").val(paramOrder.email);
        $("#input-phone").val(paramOrder.soDienThoai);
        $("#input-address").val(paramOrder.diaChi);
        $("#input-message").val(paramOrder.loiNhan);
        $("#input-ngay-order").val(paramOrder.ngayTao);
        $("#input-ngay-chinhsua").val(paramOrder.ngayCapNhat);
    }

    function confirmSuccess(){
        alert("Confirm thành công");
        getApiAllOrder();
        $("#order-modal").modal("hide")
    }
    function cancelSuccess(){
      alert("Đã Cancel đơn hàng");
        getApiAllOrder();
        $("#order-modal").modal("hide")
    }
</script>
</html>